from glLib import *

Screen = (800,600)
Window = glLibWindow(Screen,caption="Shader Demo - CTRLS: n, p, click+drag, scroll",multisample=False)

View2D = glLibView2D((0,0,Screen[0],Screen[1]))
View3D = glLibView3D((0,0,Screen[0],Screen[1]),45,0.1,200)

ParallaxShader = glLibShader()
ParallaxShader.user_variables("""
uniform float parallax, normalmapping;""")
ParallaxShader.render_equation("""
vec4 texsample = tex(tex1,uv);
color += ambient_light0_factor*texsample;
if (normalmapping==1.0) {
    color += diffuse_light0_factor_nm*texsample;
    color += specular_light0_factor_nm*texsample;
}
else {
    color += diffuse_light0_factor*texsample;
    color += specular_light0_factor*texsample;
}
""")
ParallaxShader.vertex_transform("""""")
ParallaxShader.uv_transform("""
uv *= 8.0;
uv = parallaxmap(heightmap,uv,parallax,false,-parallax);""")
ParallaxShader.compile()
errors = ParallaxShader.get_errors()
if errors != "":pygame.quit();raw_input(errors);sys.exit()
print "No errors to report!"

Ship = glLibObject("data/objects/Spaceship.obj",GLLIB_MIPMAP_BLEND,GLLIB_FILTER)

Texture = glLibTexture("data/diff.jpg",256,256,GLLIB_RGBA,GLLIB_MIPMAP_BLEND,GLLIB_FILTER)
HeightMap = glLibTexture("data/heightcontr.jpg",256,256,GLLIB_RGBA,GLLIB_MIPMAP_BLEND,GLLIB_FILTER)
NormalMap = glLibTexture("data/normal2.png",255,255,GLLIB_RGBA,GLLIB_MIPMAP_BLEND,GLLIB_FILTER)

glEnable(GL_LIGHT0)

parallax = 0.0
normalmapping = 0.0

rot = [45,-25]
camerarot = [0,0]
cameraradius = 2
def GetInput():
    global cameraradius,camerarot,rot,lightpos
    global parallax, normalmapping
    mrel = pygame.mouse.get_rel()
    mpress = pygame.mouse.get_pressed()
    key = pygame.key.get_pressed()
    for event in pygame.event.get():
        if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            if event.key == K_s and (key[K_LCTRL] or key[K_RCTRL]):
                glLibScreenshot("Screenshot.png")
            if event.key == K_n:
                normalmapping = 1.0 - normalmapping
            if event.key == K_p:
                parallax = 0.1 - parallax
        if event.type == MOUSEBUTTONDOWN:
            if event.button == 4: cameraradius -= 0.1
            if event.button == 5: cameraradius += 0.1
##    if mpress[0]:
##        camerarot[0] = clamp(80,-15,camerarot[0]+mrel[1])
##        camerarot[1] += mrel[0]
##    if mpress[1]:
##        lightpos[0] += mrel[0]
##        lightpos[2] += mrel[1]
    if mpress[0]:
        rot[0] += mrel[1]
        rot[1] += mrel[0]
def clamp(high,low,value):
    return min(high,max(low,value))
def DrawTeapot():
    glPushMatrix()
    glRotatef(rot[1],0,1,0)
    glRotatef(rot[0],1,0,0)
    glutSolidTeapot(1.0)
    glPopMatrix()
def DrawFloor():
    glBegin(GL_QUADS)
    glNormal3f(0,1,0)
    size = 10
    glVertex3f(-size,-1, size)
    glVertex3f( size,-1, size)
    glVertex3f( size,-1,-size)
    glVertex3f(-size,-1,-size)
    glEnd()
glLibUseMaterial("Gold")
def DrawShip(shader):
    glLibUseShader(shader)
    glPushMatrix()
    glRotatef(rot[1],0,1,0)
    glRotatef(rot[0],1,0,0)
    Ship.draw(shader)
    glPopMatrix()
lightpos = [0,0,2]
def Draw():
    View3D.set_view()
    Window.clear()
    camerapos = [cameraradius*cos(radians(camerarot[1]+90))*cos(radians(camerarot[0])),
                 cameraradius*sin(radians(camerarot[0])),
                 cameraradius*sin(radians(camerarot[1]+90))*cos(radians(camerarot[0]))]
    gluLookAt(camerapos[0],camerapos[1],camerapos[2],
              0,0,0,
              0,1,0)
    glLightfv(GL_LIGHT0,GL_POSITION,[lightpos[0],lightpos[1],lightpos[2],1.0])
    glLibUseShader(ParallaxShader)
    ParallaxShader.pass_texture(Texture)
    ParallaxShader.pass_heightmap(HeightMap)
    ParallaxShader.pass_normalmap(NormalMap)
    ParallaxShader.pass_float(parallax,"parallax")
    ParallaxShader.pass_float(normalmapping,"normalmapping")
    DrawShip(ParallaxShader)
    
##    glLibBlur((0,0,Screen[0],Screen[1]),GLLIB_SHADER_BLUR,4,[1.0/Screen[0],1.0/Screen[1]])
    
    Window.flip()
def main():
    while True:
        GetInput()
        Draw()
##    import time
##    while True:
##        t1 = time.time()
##        for x in xrange(100):
##            Draw()
##        t2 = time.time()
##        print "fps: %f" % round(1.0/((t2-t1)/100.0),2)
if __name__ == '__main__':
    glLibTestErrors(main)
