from glLibLocals import *
from glLibTexturing import glLibTexture
def glLibScreenshot(path,overwrite=False):
    size = glGetFloatv(GL_VIEWPORT)
    size = [int(round(size[2])),int(round(size[3]))]
    glPixelStorei(GL_PACK_ALIGNMENT,4)
    glPixelStorei(GL_PACK_ROW_LENGTH,0)
    glPixelStorei(GL_PACK_SKIP_ROWS,0)
    glPixelStorei(GL_PACK_SKIP_PIXELS,0)
    data = glReadPixels(0,0,size[0],size[1],GL_RGB,GL_UNSIGNED_BYTE)
    surface = pygame.image.fromstring(data,size,'RGB',1)
    if overwrite:
        pygame.image.save(surface,path)
    else:
        path = path.split(".")
        counter = 1
        while True:
            try:pygame.image.load(path[0]+"."+path[1])
            except:break
            counter += 1
        if counter == 1:
            pygame.image.save(surface,path[0]+"."+path[1])
        else:
            pygame.image.save(surface,path[0]+"_"+str(counter)+"."+path[1])
def glLibGetColorAt(windowcoord):
    viewport = glGetIntegerv(GL_VIEWPORT)
    winX = windowcoord[0]
    winY = viewport[3]-windowcoord[1]
    return glReadPixels(winX,winY,1,1,GL_RGBA,GL_FLOAT)
def glLibGetDepthAt(windowcoord):
    viewport = glGetIntegerv(GL_VIEWPORT)
    modelview = glGetDoublev(GL_MODELVIEW_MATRIX)
    projection = glGetDoublev(GL_PROJECTION_MATRIX)
    winX = windowcoord[0]
    winY = viewport[3]-windowcoord[1]
    winZ = glReadPixels(winX,winY,1,1,GL_DEPTH_COMPONENT,GL_FLOAT)
    return gluUnProject(winX,winY,winZ,modelview,projection,viewport)
def glLibSceneToTexture(rect,texture=None):
    if texture==None: texture = glGenTextures(1)
    glBindTexture(GL_TEXTURE_2D,texture)
    glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,rect[0],rect[1],rect[2],rect[3],0)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
    return texture
def glLibSceneToShadowMap(size,texture=None):
    if texture==None: texture = glGenTextures(1)
    glBindTexture(GL_TEXTURE_2D,texture)
    glCopyTexImage2D(GL_TEXTURE_2D,0,GL_DEPTH_COMPONENT,0,0,size,size,0)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE_ARB, GL_COMPARE_R_TO_TEXTURE_ARB)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC_ARB, GL_LEQUAL)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
    return texture
def glLibShadowGetProjMat(lightpos,center,angle,near,far):
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(angle,1.0,near,far)
    LightProjectionMatrix = glGetFloatv(GL_PROJECTION_MATRIX)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    gluLookAt(lightpos[0],lightpos[1],lightpos[2],
              center[0],center[1],center[2],
              0.0,1.0,0.0)
    
    LightViewMatrix = glGetFloatv(GL_MODELVIEW_MATRIX)

##    glMatrixMode(GL_MODELVIEW)
##    glPushMatrix()
##    glLoadMatrixf([[0.5,0.0,0.0,0.0],
##                   [0.0,0.5,0.0,0.0],
##                   [0.0,0.0,0.5,0.0],
##                   [0.5,0.5,0.5,1.0]])
##    glMultMatrixf(LightProjectionMatrix)
##    glMultMatrixf(LightViewMatrix)
##    TextureMatrix = glGetFloatv(GL_TRANSPOSE_MODELVIEW_MATRIX)
##    glPopMatrix()
    glMatrixMode(GL_TEXTURE)
    glPushMatrix()
    glLoadMatrixf([[0.5,0.0,0.0,0.0],
                   [0.0,0.5,0.0,0.0],
                   [0.0,0.0,0.5,0.0],
                   [0.5,0.5,0.5,1.0]])
    glMultMatrixf(LightProjectionMatrix)
    glMultMatrixf(LightViewMatrix)
    TextureMatrix = glGetFloatv(GL_TEXTURE_MATRIX)
    glPopMatrix()
    return TextureMatrix
def glLibTestErrors(function):
    try:
        function()
    except Exception, e:
        tb = sys.exc_info()[2]
        traceback.print_exception(e.__class__, e, tb)
        pygame.quit()
        raw_input()
        sys.exit()
def glLibErrors(value):
    if value:
        error.ErrorChecker.registerChecker(None)
    else:
        error.ErrorChecker.registerChecker(lambda: None)
